<?php
namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00050001QuantidadeMaximaParcelasOperadorService;
use SM\Traits\TResponse;

class Sm00050001QuantidadeMaximaParcelasOperadorController
{
    use TResponse;
    
    protected $qtdMaxParcelasService;
    
    public function __construct(Sm00050001QuantidadeMaximaParcelasOperadorService $qtdMaxParcelasService)
    {
        $this->qtdMaxParcelasService = $qtdMaxParcelasService;
    }
    
    public function getQuantidadeMaximaParcelasOperador()
    {
        try {
            $data = $this->qtdMaxParcelasService->getQuantidadeMaximaParcelasOperador();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveQtdMaximaParcelasOperador(DTO\Request $request)
    {
        try {
            $this->qtdMaxParcelasService->saveQtdMaximaParcelasOperador($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function deleteQtdMaximaParcelasOperador(DTO\Request $request)
    {
        try {
            $this->qtdMaxParcelasService->deleteQtdMaximaParcelasOperador($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
